//: C14:Car.cpp
// From Thinking in C++, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 2000
// Copyright notice in Copyright.txt
// Public composition
// modified by i.m. on 9 nov 2008

class Engine {
public:
  void start() const {}
  void rev() const {}
  void stop() const {}
};

class Wheels {
public:
  void inflate(int psi) const {}
};

class Window {
public:
  void rollup() const {}
  void rolldown() const {}
};

class Door {
public:
  Window window;
  void open() const {}
  void close() const {}
};

class Car {
public:
  Engine engine;
  Wheels wheels;
  Door left, right; // 2-door
};

int main() {
  Car car;
  car.left.window.rollup();
  car.wheels.inflate(72);
} ///:~
